//+------------------------------------------------------------------+
//|                                                     volatilnost-15-min.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Swan"
#property link      "http://ruforum.forexpeoples.com"
#property indicator_separate_window
#property indicator_minimum -20
#property indicator_buffers 1
#property indicator_color1 PaleGreen
extern int Limit=10000;
double ExtMapBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorDigits(2);
   SetIndexStyle(0,DRAW_HISTOGRAM,0,2);
   SetIndexBuffer(0,ExtMapBuffer);
   IndicatorShortName("forexnew");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(WindowFind("forexnew"),OBJ_TEXT);
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
if(Period()!=15) return(0);
int N[96];
double SR[96],TimeArray[96];
double Amount=0; int Total=0;
if(Limit>Bars) Limit=Bars;
for(int i=0;i<Limit;i++)
   {
   int n=(60*TimeHour(Time[i])+TimeMinute(Time[i]))/15;
   TimeArray[n]+=(High[i]-Low[i]); N[n]++;
   Amount+=(High[i]-Low[i]); Total++;
   }
for(i=0;i<96;i++)
   {
   if(N[n]!=0) SR[i]=TimeArray[i]/N[i];
   else SR[i]=0;
   }
ArrayInitialize(ExtMapBuffer,0.0);
for(i=0;i<96;i++) ExtMapBuffer[i]=100*Total*SR[95-i]/Amount;
ObjectsDeleteAll(WindowFind("forexnew"),OBJ_TEXT);
int Window=WindowFind("forexnew");
int h=0,m=0;
for(i=0;i<96;i++)
   {
   ObjectCreate("Time"+i,OBJ_TEXT,Window,Time[95-i],-10);
   string Text=h+":"+m;
   if(h<10) Text="0"+Text;
   if(m==0) Text=Text+"0";
   ObjectSetText("Time"+i,Text,8,"Arial Bold",Silver);
   ObjectSet("Time"+i,OBJPROP_ANGLE,90);
   m+=15; if(m>45) {h++;m=0;}
   }
WindowRedraw();
double PriceMax=WindowPriceMax(Window);
for(i=0;10*(i+1)<PriceMax && i<32;i++) SetLevelValue(i,10*(i+1));
SetLevelStyle(STYLE_DOT,1,Silver);
WindowRedraw();
  return(0);
}
//+------------------------------------------------------------------+